#include	"loader.inc"

#ifdef	USE_AS86
#define	CON(x)	*x
#define	LOC(x)	x
#define	WLOC(x)	x
#define	STRDECL(x)	.ascii	x
#define	JMP	jmp
#define	SEGES	seg	es
	.text
#endif
#ifdef	USE_NASM
#define	CON(x)	x
#define	LOC(x)	[x]
#define	WLOC(x)	word [x]
#define	STRDECL(x)	db	x
#define	JMP	jmp short
#define	SEGES	es
	section	.text
#endif

	org	0x100

_main:
	mov	si,CON(0x100+_body-_main)
; Relocate body of boot code to SCRATCH:0
	cld
	xor	di,di			; di = 0
	mov	ax,CON(SCRATCH)
        mov     es,ax
	mov	cx,CON(COMSIZE/2)	; copy COMSIZE bytes
	push	cx			; save cx before decrementing
#ifdef	USE_AS86
	seg	cs
#endif
#ifdef	USE_NASM
	cs
#endif
        rep
        movsw

; Save com CS and length in floppy boot block before jumping to relocated
; code
	pop	cx
	push	ds
	mov	ax,CON(FLOPPY_SEGMENT)
	mov	ds,ax
	mov	ax,cs
	mov	LOC(ROM_SEGMENT),ax
	mov	LOC(ROM_LENGTH),cx
	pop	ds

; Change stack
	mov	bx,CON(SCRATCH)		;  new ss
	mov	ds,bx			;  new ds

	int	0x12			;  get conventional memory size in KB
	shl	ax,CON(6)
	sub	ax,bx			
	shl	ax,CON(4)		;  new sp
	cli
	mov	ss,bx
	mov	sp,ax
#ifdef	ENTRYPOINT
	call	ENTRYPOINT
#else
	call	SCRATCH:6
#endif
	int	0x19			; should never reach here

; The body of etherboot is attached here at build time
; Force 4 byte alignment
#ifdef	USE_AS86
	if	((*-_main)&3) != 0
	rmb	3-((*-_main)&3)
	db	0
	endif
#endif
#ifdef	USE_NASM
	%if	(($-_main)&3) != 0
	times	3-(($-_main)&3) db 0
	db	0
	%endif
#endif
_body:
